=== debian/changelog ===
crystal (0.34.0+dfsg-1ubuntu1) hirsute; urgency=medium

  * debian/control:
    - don't build-depends on libraries which are not available

 -- Sebastien Bacher <seb128@ubuntu.com>  Tue, 24 Nov 2020 15:25:22 +0100

crystal (0.34.0+dfsg-1) unstable; urgency=medium

  * Initial release (Closes: #822275).

 -- David Suárez <david.sephirot@gmail.com>  Fri, 10 Apr 2020 17:26:40 +0200
