=== debian/control ===
Source: crystal
Section: devel
Priority: optional
Maintainer: David Suárez <david.sephirot@gmail.com>
Build-Depends: debhelper-compat (= 12),
               git,
               libbsd-dev,
               libedit-dev,
               libevent-dev,
               libgc-dev (>= 1:7.6.0),
               libgmp-dev,
               libllvm9 | libllvm8,
               libpcre3-dev,
               libssl-dev,
               libtool,
               libxml2-dev,
               libyaml-dev,
               libz-dev,
               lld-9 | lld-8,
               llvm-9-dev | llvm-8-dev,
               pkg-config
Standards-Version: 4.5.0
Homepage: https://crystal-lang.org/
Vcs-Git: https://salsa.debian.org/deiv-guest/crystal-lang.git
Vcs-Browser: https://salsa.debian.org/deiv-guest/crystal-lang
Rules-Requires-Root: no

Package: crystal-lang
Architecture: amd64
Depends: libjs-codemirror,
         libjs-jquery,
         octicons,
         pkg-config,
         ${misc:Depends},
         ${shlibs:Depends}
Suggests: crystal-lang-doc, crystal-lang-samples
Description: compiler of the Crystal object-oriented programming language
 The Crystal's language syntax is inspired by Ruby, the language is statically
 type-checked but does not require that the type of variables or method
 arguments be specified.
 .
 The language has the following goals: (1) have the same syntax as Ruby, or at
 least as similar as possible; (2) statically type-checked but without having
 to specify the type of variables or method arguments; (3) be able to call C
 code by writing bindings to it in Crystal; (4) have compile-time evaluation
 and generation of code, to avoid boilerplate code; (5) compile to efficient
 native code.

Package: crystal-lang-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Suggests: www-browser
Description: API documentation for the Crystal object-oriented programming language
 The Crystal's language syntax is inspired by Ruby, the language is statically
 type-checked but does not require that the type of variables or method
 arguments be specified.
 .
 This package contains the documentation for the standard library.

Package: crystal-lang-samples
Architecture: all
Depends: ${misc:Depends}
Description: samples for the Crystal object-oriented programming language
 The Crystal's language syntax is inspired by Ruby, the language is statically
 type-checked but does not require that the type of variables or method
 arguments be specified.
 .
 This package contains some samples for starting to play with the language.
