## crystal 1.2.1+dfsg

=== debian/changelog ===
crystal (1.2.1+dfsg-5) unstable; urgency=medium

  * Add patch 'disable-udp-multicast-specs'.

 -- David Suárez <deiv@debian.org>  Mon, 01 Nov 2021 20:54:47 +0100

crystal (1.2.1+dfsg-4) unstable; urgency=medium

  * Use gcc10 until upstream adds support for DWARF 5 (gcc11).

 -- David Suárez <deiv@debian.org>  Mon, 01 Nov 2021 18:30:29 +0100

crystal (1.2.1+dfsg-3) unstable; urgency=medium

  * Use LLVM 12 until 13 gets unblocked.
  * Source upload.

 -- David Suárez <deiv@debian.org>  Sun, 31 Oct 2021 22:49:43 +0100

crystal (1.2.1+dfsg-2) unstable; urgency=medium

  * d/control:
    - Update standars version (no changes needed).
    - Point Vcs-* fields to the updated git repository.
    - Update maintainer to debian account.
    - Update LLVM version.
    - Rename packages to crystal (remove -lang).
    - Add build depend on itself.
  * Update d/copyright.

 -- David Suárez <deiv@debian.org>  Sat, 30 Oct 2021 15:03:25 +0200

crystal (1.2.1+dfsg-1) unstable; urgency=medium

  * New upstream version.
  * Update installed files, now makefile comes with install target.
  * Install bash-completion files with the correct name (Closes: #984955).
  * d/rules:
    - Update regex to remove privacy-breach-generic links.
    - Clean gzipped man page.
  * d/control:
    - remove some incorrect build-depends (Closes: #966014)
  * d/patches:
    - drop 'fix-cookie-expire-time-check'; Applied upstream.
    - drop 'update-support-jquery-3'; Applied upstream.
    - drop 'update-packaged-javascript-links'; Not needed.
  * d/copyright: exclude all the minimized javascript code.
  * Compile without support for the playground:
    - The octicons fonts library is removed from testing, so we don't
        build the compiler with the html playground support.
    - Remove all the javascript libraries runtime dependencies.
    - Remove all the copyright's related to the excluded javascript files.
    - Remove 'd/crystal-lang.links'.
    - Remove 'd/missing-sources/materialize.js'.

 -- David Suárez <deiv@debian.org>  Sat, 23 Oct 2021 16:12:16 +0200
