=== debian/control ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Source: crystal
 Section: devel
 Priority: optional
-Maintainer: David Suárez <david.sephirot@gmail.com>
+Maintainer: David Suárez <deiv@debian.org>
 Build-Depends: debhelper-compat (= 12),
                git,
                libbsd-dev,
@@ -16,24 +16,24 @@
                libxml2-dev,
                libyaml-dev,
                libz-dev,
-               lld-9 | lld-8,
-               llvm-9-dev | llvm-8-dev,
-               pkg-config
-Standards-Version: 4.5.0
+               lld-12 | lld-9 | lld-8,
+               llvm-12-dev | llvm-9-dev | llvm-8-dev,
+               pkg-config,
+               crystal (>= 1.2.1),
+               gcc-10,
+               g++-10
+Standards-Version: 4.6.0
 Homepage: https://crystal-lang.org/
-Vcs-Git: https://salsa.debian.org/deiv-guest/crystal-lang.git
-Vcs-Browser: https://salsa.debian.org/deiv-guest/crystal-lang
+Vcs-Git: https://salsa.debian.org/deiv/crystal.git
+Vcs-Browser: https://salsa.debian.org/deiv/crystal
 Rules-Requires-Root: no
 
-Package: crystal-lang
+Package: crystal
 Architecture: amd64
-Depends: libjs-codemirror,
-         libjs-jquery,
-         octicons,
-         pkg-config,
+Depends: pkg-config,
          ${misc:Depends},
          ${shlibs:Depends}
-Suggests: crystal-lang-doc, crystal-lang-samples
+Suggests: crystal-doc, crystal-samples
 Description: compiler of the Crystal object-oriented programming language
  The Crystal's language syntax is inspired by Ruby, the language is statically
  type-checked but does not require that the type of variables or method
@@ -46,7 +46,7 @@
  and generation of code, to avoid boilerplate code; (5) compile to efficient
  native code.
 
-Package: crystal-lang-doc
+Package: crystal-doc
 Section: doc
 Architecture: all
 Depends: ${misc:Depends}
@@ -58,7 +58,7 @@
  .
  This package contains the documentation for the standard library.
 
-Package: crystal-lang-samples
+Package: crystal-samples
 Architecture: all
 Depends: ${misc:Depends}
 Description: samples for the Crystal object-oriented programming language
