=== debian/changelog ===
crystal (1.2.2+dfsg-1) unstable; urgency=medium

  * New upstream version.
  * Use latest gcc version again.
  * Remove old llvm versions (8 & 9) (Closes: #1001546).

 -- David Suárez <deiv@debian.org>  Thu, 06 Jan 2022 15:21:25 +0100

crystal (1.2.1+dfsg-6) unstable; urgency=medium

  * Fix install target, to allow build arch and indep separately.

 -- David Suárez <deiv@debian.org>  Sun, 07 Nov 2021 17:13:57 +0100
