=== debian/control ===
--- 
+++ 
@@ -9,19 +9,16 @@
                libevent-dev,
                libgc-dev (>= 1:7.6.0),
                libgmp-dev,
-               libllvm9 | libllvm8,
                libpcre3-dev,
                libssl-dev,
                libtool,
                libxml2-dev,
                libyaml-dev,
                libz-dev,
-               lld-12 | lld-9 | lld-8,
-               llvm-12-dev | llvm-9-dev | llvm-8-dev,
+               lld-12,
+               llvm-12-dev,
                pkg-config,
-               crystal (>= 1.2.1),
-               gcc-10,
-               g++-10
+               crystal (>= 1.2.1)
 Standards-Version: 4.6.0
 Homepage: https://crystal-lang.org/
 Vcs-Git: https://salsa.debian.org/deiv/crystal.git
