=== debian/rules ===
--- 
+++ 
@@ -21,21 +21,19 @@
 	dh $@
 
 override_dh_auto_build:
-	CC="gcc-10" CXX="g++-10" dh_auto_build -- $(make_options)
+	dh_auto_build -- $(make_options)
 	make $(make_options) docs
 
+override_dh_auto_install: DESTDIR=$(CURDIR)/debian/tmp
 override_dh_auto_install:
 	dh_auto_install -- PREFIX=/usr
 
-override_dh_install:
-	dh_install
-	
 	#
 	# clean lib dir, but without deleting (needed by extensions loading):
 	#   - ext/libcrystal.a
 	#   - llvm/ext/{find-llvm-config, llvm_ext.o)
 	#
-	find "debian/crystal/usr/lib/crystal/" \
+	find "$(DESTDIR)/usr/share/crystal/src" \
 		-iname "sigfault.o" -or \
 		-iname "*.c" -or \
 		-iname "*.cc" \
@@ -43,7 +41,7 @@
 	
 	# fix privacy-breach-generic links on html docs
 	sed -i  '/<p><a href=/{:a;N;/alt="born-and-raised" \/><\/a><\/p>/!ba};//d' \
-		debian/crystal-doc/usr/share/doc/crystal/api-docs/index.html
+		docs/index.html
 
 override_dh_auto_test:
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
