=== debian/changelog ===
crystal (1.3.2+dfsg-1) unstable; urgency=medium

  * New upstream version.
  * Switch to llvm-toolchain-13 (Closes: #1004882).
  * Add missing dependency on libgc-dev (Closes: #1010249).
  * Update standars version; No changes needed.
  * Update remove privacy-breach sed expression.
  * Use makefile install target.
  * Add patch 'remove-check-in-random-failing-test'.
  * Run primitives spec.

 -- David Suárez <deiv@debian.org>  Sun, 12 Jun 2022 21:16:22 +0200
