=== debian/control ===
--- 
+++ 
@@ -15,11 +15,11 @@
                libxml2-dev,
                libyaml-dev,
                libz-dev,
-               lld-12,
-               llvm-12-dev,
+               lld-13,
+               llvm-13-dev,
                pkg-config,
                crystal (>= 1.2.1)
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Homepage: https://crystal-lang.org/
 Vcs-Git: https://salsa.debian.org/deiv/crystal.git
 Vcs-Browser: https://salsa.debian.org/deiv/crystal
@@ -29,7 +29,8 @@
 Architecture: amd64
 Depends: pkg-config,
          ${misc:Depends},
-         ${shlibs:Depends}
+         ${shlibs:Depends},
+         libgc-dev
 Suggests: crystal-doc, crystal-samples
 Description: compiler of the Crystal object-oriented programming language
  The Crystal's language syntax is inspired by Ruby, the language is statically
@@ -63,4 +64,4 @@
  type-checked but does not require that the type of variables or method
  arguments be specified.
  .
- This package contains some samples for starting to play with the language.
+ This package contains some examples for starting to play with the language.
