=== debian/rules ===
--- 
+++ 
@@ -22,7 +22,6 @@
 
 override_dh_auto_build:
 	dh_auto_build -- $(make_options)
-	make $(make_options) docs
 
 override_dh_auto_install: DESTDIR=$(CURDIR)/debian/tmp
 override_dh_auto_install:
@@ -38,15 +37,21 @@
 		-iname "*.c" -or \
 		-iname "*.cc" \
 		| xargs rm
+		
+	make install_docs DATADIR=$(DESTDIR)/usr/share/doc/crystal
 	
 	# fix privacy-breach-generic links on html docs
-	sed -i  '/<p><a href=/{:a;N;/alt="born-and-raised" \/><\/a><\/p>/!ba};//d' \
-		docs/index.html
+	sed -i  '/<p><a href=/{:a;N;/alt="Crystal - Born and raised at Manas" \/><\/a><\/p>/!ba};//d' \
+		$(DESTDIR)/usr/share/doc/crystal/docs/index.html
+		
+	# remove vcs file in examples
+	rm -f $(DESTDIR)/usr/share/doc/crystal/examples/.gitignore
 
 override_dh_auto_test:
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
 	make $(make_options) compiler_spec
 	make $(make_options) std_spec
+	make $(make_options) primitives_spec
 endif
