=== debian/changelog ===
crystal (1.6.0+dfsg-3) unstable; urgency=medium

  * Update runtime depends (Closes: #1031812).

 -- David Suárez <deiv@debian.org>  Fri, 03 Mar 2023 19:03:34 +0100

crystal (1.6.0+dfsg-2) unstable; urgency=medium

  * Source upload.

 -- David Suárez <deiv@debian.org>  Tue, 11 Oct 2022 21:08:52 +0200

crystal (1.6.0+dfsg-1) unstable; urgency=medium

  * New upstream version.
  * d/patches:
    - Refresh patch 'remove-check-in-random-failing-test'.
    - Add patch 'fix-sbuild-pkgbuilddir-filtering-in-unix-spec'
      (Closes: #1017565).
  * Switch to llvm-toolchain-14 (Closes: #1017662).

 -- David Suárez <deiv@debian.org>  Sun, 09 Oct 2022 20:02:18 +0200
