=== debian/control ===
--- 
+++ 
@@ -15,10 +15,10 @@
                libxml2-dev,
                libyaml-dev,
                libz-dev,
-               lld-13,
-               llvm-13-dev,
+               lld-14,
+               llvm-14-dev,
                pkg-config,
-               crystal (>= 1.2.1)
+               crystal (>= 1.6.0)
 Standards-Version: 4.6.1
 Homepage: https://crystal-lang.org/
 Vcs-Git: https://salsa.debian.org/deiv/crystal.git
@@ -27,10 +27,14 @@
 
 Package: crystal
 Architecture: amd64
-Depends: pkg-config,
-         ${misc:Depends},
+Depends: ${misc:Depends},
          ${shlibs:Depends},
-         libgc-dev
+         gcc,
+         libgc-dev,
+         pkg-config,
+         libpcre3-dev,
+         libevent-dev
+Recommends: libssl-dev, libz-dev, libxml2-dev, libgmp-dev, libyaml-dev
 Suggests: crystal-doc, crystal-samples
 Description: compiler of the Crystal object-oriented programming language
  The Crystal's language syntax is inspired by Ruby, the language is statically
