=== debian/rules ===
--- 
+++ 
@@ -13,6 +13,7 @@
 make_options += threads=$(N_CPUS)
 make_options += CRYSTAL_CONFIG_PATH="lib:/usr/lib/crystal/lib"
 make_options += CRYSTAL_CACHE_DIR="/tmp/crystal"
+#make_options += interpreter=1
 
 export FLAGS = -Dwithout_playground
